<?php namespace SokoWeb\Interfaces\PersistentData;

use Generator;
use SokoWeb\Database\Query\Select;
use SokoWeb\PersistentData\Model\Model;

interface IPersistentDataManager
{
    public function selectFromDb(Select $select, string $type, bool $useRelations = false, array $withRelations = []);

    public function selectMultipleFromDb(Select $select, string $type, bool $useRelations = false, array $withRelations = []): Generator;

    public function selectFromDbById($id, string $type, bool $useRelations = false, array $withRelations = []);

    public function selectFromDbBySlug(string $slug, string $type, bool $useRelations = false, array $withRelations = []);

    public function loadRelationsFromDb(Model $model, bool $recursive = false, array $withRelations = []): void;

    public function saveToDb(Model $model): void;

    public function deleteFromDb(Model $model): void;
}
